import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'my_plugin_test_project_method_channel.dart';

abstract class MyPluginTestProjectPlatform extends PlatformInterface {
  /// Constructs a MyPluginTestProjectPlatform.
  MyPluginTestProjectPlatform() : super(token: _token);

  static final Object _token = Object();

  static MyPluginTestProjectPlatform _instance = MethodChannelMyPluginTestProject();

  /// The default instance of [MyPluginTestProjectPlatform] to use.
  ///
  /// Defaults to [MethodChannelMyPluginTestProject].
  static MyPluginTestProjectPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [MyPluginTestProjectPlatform] when
  /// they register themselves.
  static set instance(MyPluginTestProjectPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
