import 'package:flutter_test/flutter_test.dart';
import 'package:my_plugin_test_project/my_plugin_test_project.dart';
import 'package:my_plugin_test_project/my_plugin_test_project_platform_interface.dart';
import 'package:my_plugin_test_project/my_plugin_test_project_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockMyPluginTestProjectPlatform
    with MockPlatformInterfaceMixin
    implements MyPluginTestProjectPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');
}

void main() {
  final MyPluginTestProjectPlatform initialPlatform = MyPluginTestProjectPlatform.instance;

  test('$MethodChannelMyPluginTestProject is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelMyPluginTestProject>());
  });

  test('getPlatformVersion', () async {
    MyPluginTestProject myPluginTestProjectPlugin = MyPluginTestProject();
    MockMyPluginTestProjectPlatform fakePlatform = MockMyPluginTestProjectPlatform();
    MyPluginTestProjectPlatform.instance = fakePlatform;

    expect(await myPluginTestProjectPlugin.getPlatformVersion(), '42');
  });
}
